"""
    MoinMoin - CommandContract Class

    Copyright (c) 2003 by gian paolo ciceri <gp.ciceri@acm.org>
    All rights reserved, see COPYING for details.

    This class try to implement a simplicistic DBC Pattern for the
    process method. It's designed to help command process building.

"""

# Imports

from MoinMoin import config, wikiutil
import re, cStringIO


class Contract:

    def __init__(self):
        self.invariant()

    def invariant(self):
        pass

    def requireProcess(self, *args, **kw):
        # be sure the 1st argument is a MoinMoin.wikimacro.Macro instance
        assert args[0].__class__.__module__ == 'MoinMoin.wikimacro'
        assert args[0].__class__.__name__ == 'Macro'

    def ensureProcess(self, *args, **kw):
        pass

    def dbc__process(self, *args, **kw):
        self.invariant()
        self.requireProcess(*args, **kw)
        result = self.process(*args, **kw)
        self.invariant()
        self.ensureProcess(*args, **kw)
        return result

    def process(self, *args, **kw):
        macro = args[0]
        return 'dummy string'
    
